/* Librairies */
#include <ESP32Servo.h>
#include <WiFi.h>
#include "scripts.h"
#include "styles.h"
#include "nipplejs.h"

const char* ssid     = "Nom_Reseau_Wifi";
const char* password = "password_wifi";

Servo monServo;
static const int relayPin = 19; // GPIO19
static const int servoPin = 18; // GPIO18
static const int ENBPin = 4; // GPIO4
static const int IN3Pin = 6;  // GPIO6
static const int IN4Pin = 5;  // GPIO5

int pos = 0;

WiFiServer server(80);
String header;
String EtatMoteur = "Arret";
String EtatServo = "Droit";

void setup() {
  ESP32PWM::allocateTimer(0);
  ESP32PWM::allocateTimer(1);
  ESP32PWM::allocateTimer(2);
  ESP32PWM::allocateTimer(3);
  monServo.setPeriodHertz(50);
  monServo.attach(servoPin, 700, 2300);

  Serial.begin(115200);
  pinMode(IN3Pin, OUTPUT);
  pinMode(IN4Pin, OUTPUT);
  pinMode(ENBPin, OUTPUT);

  pinMode(relayPin, OUTPUT);

  digitalWrite(relayPin, LOW);
  
  digitalWrite(IN3Pin, LOW);
  digitalWrite(IN4Pin, LOW);
  analogWrite(ENBPin, 0);
  monServo.write(90);

  Serial.print("Configuration AP (Point d'accès)…");
  WiFi.softAP(ssid, password);

  IPAddress IP = WiFi.softAPIP();
  Serial.print("Adresse IP du point d'accès : ");
  Serial.println(IP);
   // Afficher le SSID et le mot de passe sur le moniteur série
  Serial.print("SSID: ");
  Serial.println(ssid);
  Serial.print("Password: ");
    Serial.println(password);
  server.begin();
}

void loop() {
  WiFiClient client = server.available();

  if (client) {
    Serial.println("Nouveau client.");
    String currentLine = "";
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        Serial.write(c);
        header += c;
        if (c == '\n') {
          if (currentLine.length() == 0) {
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println("Connection: close");
            client.println();

            if (header.indexOf("GET /vitesse=") >= 0) {
              int pos = header.indexOf("GET /vitesse=") + 13;
              int vitesse = header.substring(pos, pos + 3).toInt();
              Serial.println("Vitesse : " + String(vitesse));
              analogWrite(ENBPin, vitesse);
            }

    client.println("<style>");
    client.print(FPSTR(styles_css));
    client.println("</style>");

    client.println("<script>");
    client.print(FPSTR(nipplejs_min_js));
    client.print(script_js);
    client.println("</script>");




 client.println("<html><body>");
  client.println("<h1 style='text-align: center;'>Mon Bateau</h1>");

client.println("<div class='main-container'>");

client.println("<div class='slidecontainerDir'>");
client.println("<input type='range' min='0' max='180' value='90' class='sliderDir' id='servoSlider' onchange='updateServo(this.value)'>");
client.println("</div>");

client.println("<div class='counter-container'>");
client.println("<div class='gauge'>");
client.println("<div class='needle' id='needle'></div>");
client.println("<div class='gauge-value' id='gaugeValue'>0</div>");
client.println("</div>");
client.println("</div>");


client.println("<div class='slidecontainerVit'>");
client.println("<input type='range' min='-255' max='255' value='0' id='moteurSlider' class='sliderVit' onchange='updateVitesse(this.value)'>");
client.println("</div>");

client.println("</div>"); // Ferme la balise <div class='main-container'>


client.println("<div class='bouton-container'>");
            client.println("<button class='bouton' onclick='updateServo(90);'>Direction 0</button>");
            client.println("<button class='bouton' onclick='updateVitesse(0);'>Stop moteur</button>");
client.println("</div>"); // Ferme la balise <div class='bouton-container'>

client.println("<div class='bouton-container'>");
client.println("<button class='bouton' onclick='toggleRelay();'>Toggle Relay</button>");
client.println("</div>");




            if (header.indexOf("GET /vitesse=") >= 0) {
              int pos = header.indexOf("GET /vitesse=") + 13;
              int vitesse = header.substring(pos, pos + (header[pos] == '-' ? 4 : 3)).toInt();
              Serial.println("Vitesse : " + String(vitesse));

              if (vitesse == 0) {
                EtatMoteur = "Arret";
                analogWrite(ENBPin, 0);
              } else if (vitesse > 0) {
                EtatMoteur = "Avance";
                digitalWrite(IN3Pin, HIGH);
                digitalWrite(IN4Pin, LOW);
                analogWrite(ENBPin, vitesse);
              } else {
                EtatMoteur = "Recule";
                digitalWrite(IN3Pin, LOW);
                digitalWrite(IN4Pin, HIGH);
                analogWrite(ENBPin, -vitesse);
              }
            }

            if (header.indexOf("GET /servo=") >= 0) {
              int pos = header.indexOf("GET /servo=") + 11;
              int angle = header.substring(pos, pos + 3).toInt();
              Serial.println("Angle : " + String(angle));
              monServo.write(angle);
            }

            if (header.indexOf("GET /stop") >= 0) {
              EtatMoteur = "Arret";
              analogWrite(ENBPin, 0);
            }

              if (header.indexOf("GET /toggle_relay") >= 0) {
              digitalWrite(relayPin, !digitalRead(relayPin)); // toggle the relay
              Serial.println("Relay status changed.");
            }
            client.println("</body></html>");
            client.println();
            break;
          } else {
            currentLine = "";
          }
        } else if (c != '\r') {
          currentLine += c;
        }
      }
    }
    header = "";
    client.stop();
    Serial.println("Client déconnecté.");
    Serial.println("");
  }
}

