#ifndef SCRIPTS_H
#define SCRIPTS_H
#include <Arduino.h>


const char script_js[] PROGMEM = R"=====(
document.addEventListener('DOMContentLoaded', function() {
  updateVitesse(0);
  updateServo(90);

  var joystickContainer = document.getElementById('joystickContainer');
  var joystick = nipplejs.create({ zone: joystickContainer, mode: 'static', position: { left: '50%', top: '50%' }, size: 150, color: 'blue', restJoystick: true });

  joystick.on('move', function (evt, data) {
    var angle = data.angle.degree;
    var distance = data.distance;
    // Utilisez angle et distance pour contrôler le bateau
  });

  joystick.on('end', function (evt, data) {
    // Effectuez une action lorsque le joystick est relâché
  });
});

function updateGauge(value) {
  var needle = document.getElementById('needle');
  var gaugeValue = document.getElementById('gaugeValue');
  var angle = (value / 255) * 180;
  needle.style.transform = 'rotate(' + angle + 'deg)';
  gaugeValue.textContent = value;
}

function updateVitesse(value) {
  updateGauge(value);
  var xhr = new XMLHttpRequest();
  xhr.open('GET', '/vitesse=' + value, true);
  xhr.send();
  document.getElementById('moteurSlider').value = value;
}

function updateServo(value) {
  var xhr = new XMLHttpRequest();
  xhr.open('GET', '/servo=' + value, true);
  xhr.send();
  document.getElementById('servoSlider').value = value;
}

function resetServo() {
  var xhr = new XMLHttpRequest();
  xhr.open('GET', '/servo=90', true);
  xhr.send();
}

function stopMoteur() {
  var xhr = new XMLHttpRequest();
  xhr.open('GET', '/stop', true);
  xhr.send();
}

function toggleRelay() {
  var xhttp = new XMLHttpRequest();
  xhttp.open('GET', '/toggle_relay', true);
  xhttp.send();
}
)=====";
#endif